//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AB7E21F0073.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AB7E21F0073.cm

//## begin module%4AB7E21F0073.cp preserve=no
//## end module%4AB7E21F0073.cp

//## Module: CreateBinnedPlotGroups%4AB7E21F0073; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/CreateBinnedPlotGroups.h

#ifndef CREATEBINNEDPLOTGROUPS_H
#define CREATEBINNEDPLOTGROUPS_H 1

//## begin module%4AB7E21F0073.additionalIncludes preserve=no
//## end module%4AB7E21F0073.additionalIncludes

//## begin module%4AB7E21F0073.includes preserve=yes
#include <XSPlot/Plot/PlotTypes.h>
#include <list>
//## end module%4AB7E21F0073.includes

// PlotGroupCreator
#include <XSPlot/Plot/PlotGroupCreator.h>
//## begin module%4AB7E21F0073.declarations preserve=no
//## end module%4AB7E21F0073.declarations

//## begin module%4AB7E21F0073.additionalDeclarations preserve=yes
//## end module%4AB7E21F0073.additionalDeclarations


//## begin CreateBinnedPlotGroups%4AB7CB0B0237.preface preserve=yes
//## end CreateBinnedPlotGroups%4AB7CB0B0237.preface

//## Class: CreateBinnedPlotGroups%4AB7CB0B0237
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class CreateBinnedPlotGroups : public PlotGroupCreator  //## Inherits: <unnamed>%4AB7CB9102EF
{
  //## begin CreateBinnedPlotGroups%4AB7CB0B0237.initialDeclarations preserve=yes
  //## end CreateBinnedPlotGroups%4AB7CB0B0237.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: CreateBinnedPlotGroups%4AB7CC0700C3
      CreateBinnedPlotGroups (bool isUnfolded, bool isCounts);

    //## Destructor (generated)
      virtual ~CreateBinnedPlotGroups();


    //## Other Operations (specified)
      //## Operation: createPlotGroups%4AB7CD3401B6
      virtual std::vector<PlotGroup*> createPlotGroups (const PlotSettings& settings);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: isUnfolded%4AB7CC5E00AA
      bool isUnfolded () const;

    // Additional Public Declarations
      //## begin CreateBinnedPlotGroups%4AB7CB0B0237.public preserve=yes
      //## end CreateBinnedPlotGroups%4AB7CB0B0237.public

  protected:
    // Additional Protected Declarations
      //## begin CreateBinnedPlotGroups%4AB7CB0B0237.protected preserve=yes
      //## end CreateBinnedPlotGroups%4AB7CB0B0237.protected

  private:
    //## Constructors (generated)
      CreateBinnedPlotGroups(const CreateBinnedPlotGroups &right);

    //## Assignment Operation (generated)
      CreateBinnedPlotGroups & operator=(const CreateBinnedPlotGroups &right);


    //## Other Operations (specified)
      //## Operation: itemizePlotGroupModels%4AB8F7210051
      void itemizePlotGroupModels ();

      //## Operation: initializePlotGroup%4AC1027D0080
      PlotGroup* initializePlotGroup (size_t groupIndex, std::list<SpectralData*>& groupSpectra);

      //## Operation: getNextPlotBin%4AC102980082
      bool getNextPlotBin (PlotGroup* gr, int npts, std::list<SpectralData*>& groupSpectra, int& latestChannel);

      //## Operation: integrateModelFluxes%4AC25AED02F9
      void integrateModelFluxes (std::list<SpectralData*>& spectra, Real eMin, Real eMax, PlotGroup* group, int point);

      //## Operation: setError%4AC25AF6023E
      void setError (PlotGroup* gr, int npts, Real areaSum, Real backAreaSum, Real count, Real backgroundCount, Real bscaleRatio);

      //## Operation: initEffectiveAreas%4AC36E2F00EA
      static void initEffectiveAreas (std::list<SpectralData*>& spectraInGroup);

      //## Operation: clearEffectiveAreas%4AC36E35000B
      static void clearEffectiveAreas (std::list<SpectralData*>& spectraInGroup);

    // Additional Private Declarations
      //## begin CreateBinnedPlotGroups%4AB7CB0B0237.private preserve=yes
      //## end CreateBinnedPlotGroups%4AB7CB0B0237.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin CreateBinnedPlotGroups::isUnfolded%4AB7CC5E00AA.attr preserve=no  public: bool {UC} 
      const bool m_isUnfolded;
      //## end CreateBinnedPlotGroups::isUnfolded%4AB7CC5E00AA.attr

      //## Attribute: modelPositionDirectory%4AB8F6BF0085
      //## begin CreateBinnedPlotGroups::modelPositionDirectory%4AB8F6BF0085.attr preserve=no  private: ModelPositionInfo {U} 
      ModelPositionInfo m_modelPositionDirectory;
      //## end CreateBinnedPlotGroups::modelPositionDirectory%4AB8F6BF0085.attr

      //## Attribute: modelsForSpectra%4AB8F6F20349
      //## begin CreateBinnedPlotGroups::modelsForSpectra%4AB8F6F20349.attr preserve=no  private: SpectraModelHolder {U} 
      SpectraModelHolder m_modelsForSpectra;
      //## end CreateBinnedPlotGroups::modelsForSpectra%4AB8F6F20349.attr

      //## Attribute: settings%4AB8F9BF027C
      //## begin CreateBinnedPlotGroups::settings%4AB8F9BF027C.attr preserve=no  private: const PlotSettings* {UC} 
      const PlotSettings* m_settings;
      //## end CreateBinnedPlotGroups::settings%4AB8F9BF027C.attr

      //## Attribute: counts%4AC24D7102C7
      //## begin CreateBinnedPlotGroups::counts%4AC24D7102C7.attr preserve=no  private: bool {UC} 
      const bool m_counts;
      //## end CreateBinnedPlotGroups::counts%4AC24D7102C7.attr

    // Additional Implementation Declarations
      //## begin CreateBinnedPlotGroups%4AB7CB0B0237.implementation preserve=yes
      //## end CreateBinnedPlotGroups%4AB7CB0B0237.implementation

};

//## begin CreateBinnedPlotGroups%4AB7CB0B0237.postscript preserve=yes
//## end CreateBinnedPlotGroups%4AB7CB0B0237.postscript

// Class CreateBinnedPlotGroups 

//## Get and Set Operations for Class Attributes (inline)

inline bool CreateBinnedPlotGroups::isUnfolded () const
{
  //## begin CreateBinnedPlotGroups::isUnfolded%4AB7CC5E00AA.get preserve=no
  return m_isUnfolded;
  //## end CreateBinnedPlotGroups::isUnfolded%4AB7CC5E00AA.get
}

//## begin module%4AB7E21F0073.epilog preserve=yes
//## end module%4AB7E21F0073.epilog


#endif
